; DeCrunch library
; Goldroad version
;
; (c) 1987 Copyright, Andrew Binstock   
; Translated to ARM assembly and modified for the GBA by Mic, 2001/2003
;


@define     EOS         $FFFFFFFF	; End Of Stream
@define     TRIGGER     #$FE



; DeCrunch memory write macro
@macro Output
	cmp	r10,#1
	moveq	r3,r3,lsl#8
	cmp	r10,#2
	moveq	r3,r3,lsl#16
	cmp	r10,#3
	moveq	r3,r3,lsl#24
				
	add	r10,r10,#1
	orr	r1,r1,r3
	cmp	r10,r9
	movne	r2,#0
	moveq	r2,r10
	moveq	r10,#0
	
	cmp	r2,#1
	streqb	r1,[r8],#1
	cmp	r2,#2
	streqh	r1,[r8],#2
	cmp	r2,#4
	streq	r1,[r8],#4
	
	cmp	r10,#0
	moveq	r1,#0
@endm


; void DeCrunch
;
; in:
;  r0 = src
;  r1 = dest
;  r2 = dest alignment (1=byte, 2=hword etc)
;
DeCrunch:
	stmfd	sp!,{r3-r10}
	
	; Align dest address to closest n-byte boundry
	ldr	r3,=$FFFFFFFF
	sub	r4,r2,#1
	eor	r3,r3,r4
	and	r1,r1,r3
	
	; Set up some variables
	mov	r7,r0
	mov	r8,r1
	ldr	r3,[r7],#4
	mov	r9,r2
	str	r3,[dc_stream_length]
	mov	r4,r7
	
	ldr	r0,[dc_stream_length]
		
	mov	r5,#0					; Loop counter
	mov	r1,r5					; Write buffer
	mov	r10,r5					; Write buffer counter
	DC_loop:
		cmp	r5,r0
		bge	DC_return
			
		ldrb	r3,[r4,r5]
		cmp	r3,TRIGGER
		beq 	DC_run_length
			Output
			b	DC_scalar
		
		DC_run_length:
			add	r5,r5,#1
			ldrb	r3,[r4,r5]
			cmp	r3,#0
			bne	DC_not_zero
				mov	r3,TRIGGER
				Output
				b	DC_was_zero

			DC_not_zero:
				mov	r6,r3
				add	r5,r5,#1
				ldrb	r7,[r4,r5]
				DC_put_bytes:
					cmp	r6,#0
					beq	DC_end_run
					mov	r3,r7
					Output
					sub	r6,r6,#1
					b	DC_put_bytes
				DC_end_run:

			DC_was_zero:
		DC_scalar:
		
		add	r5,r5,#1
		b DC_loop
	DC_end_loop:
		

	DC_return:
	ldmfd	sp!,{r3-r10}
	mov	pc,lr	
		

@ltorg



dc_buffer_ptr		@dcd 0
dc_buffer_ptr2		@dcd 0
dc_stream_length	@dcd 0
dc_stream_offset	@dcd 0
dc_break		@dcd 0
	


